<script setup lang="ts">
    import { SilabError } from '@/shared/errors/SilabError'
    import { isDefinedAndNotNull } from '@/shared/helpers/types'
    import SActiviteDiagnostique from '@/interventionServiceOffer/components/intervention/SActiviteDiagnostique.vue'
    import SActiviteActionItem from '@/interventionServiceOffer/components/intervention/SActiviteActionItem.vue'
    import { ActiviteActionApi } from '@/interventionServiceOffer/entities/activite/ActiviteActionApi'
    import { activiteActionMapper } from '@/interventionServiceOffer/entities/activite/ActiviteActionMapper'
    import { myselfGmaoActeurInjectionKey } from '@/interventionServiceOffer/constants'
    import SActiviteActionCreation from '@/interventionServiceOffer/components/intervention/SActiviteActionCreation.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { VTextarea } from 'vuetify/lib/components/index.mjs'
    import { pluralForm } from '@/shared/helpers/strings'
    import { securedDataArrayFilter } from '@/shared/helpers/lifeCycle'
    import { ActiviteAction } from '@/interventionServiceOffer/entities/activite/ActiviteAction'
    import { interventionPourSoldageMapper } from '@/interventionServiceOffer/entities/intervention/pourSoldage/InterventionPourSoldageMapper'
    import SDateRangeField from '@/shared/formField/components/SDateRangeField.vue'

    import {
        computed,
        ComputedRef,
        readonly,
        Ref,
        ref,
        toRaw,
        toRef,
        watchEffect,
    } from 'vue'
    import {
        isDefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'
    import { InterventionApi } from '@/interventionServiceOffer/entities/intervention/InterventionApi'
    import { useActiviteFilterStore } from '@/interventionServiceOffer/stores/ActiviteFilterStore'
    import { useStoreKeys } from '@/shared/user/composables/useStoreKeys'
    import { useInterventionActivitesDiagnostique } from '@/interventionServiceOffer/entities/activite/useInterventionActivitesDiagnostique'
    import {
        buildOriginalAwareClone,
        OriginalAwareClone,
        securedDataArrayMap,
        VolatileSecuredData,
    } from '@/shared/helpers/lifeCycle'
    import { ActiviteDiagnostique } from '@/interventionServiceOffer/entities/activite/ActiviteDiagnostique'
    import { useInterventionActivitesAction } from '@/interventionServiceOffer/entities/activite/useInterventionActivitesAction'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const myself = requiredInject(myselfGmaoActeurInjectionKey)

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const interventionServiceOffer = requiredInject(
        interventionServiceOfferInjectionKey
    )
    const afficherActivitésDéjàRéalisées = useActiviteFilterStore(
        useStoreKeys(msal).generateUserScopedStoreKey(
            'afficherActivitésDéjàRéalisé'
        ),
        { isDone: false }
    ).activiteFilters

    const props = defineProps<{
        interventionOriginale: Intervention
    }>()

    // interventions
    const intervention = ref<OriginalAwareClone<Intervention>>(
        buildOriginalAwareClone(toRaw(props.interventionOriginale))
    )

    watchEffect(() => {
        intervention.value = buildOriginalAwareClone(
            toRaw(props.interventionOriginale)
        )
    })

    const interventionApi = new InterventionApi(msal)
    const activiteActionApi = new ActiviteActionApi(msal)
    // Activité diagnostiques
    const {
        activitesDiagnostique: activitesDiagnostiqueOriginales,
        reload: reloadActivitesDiagnostiqueOriginales,
    } = useInterventionActivitesDiagnostique(
        toRef(() => props.interventionOriginale.id),
        serviceOfferId
    )

    const activitesDiagnostique =
        ref<VolatileSecuredData<OriginalAwareClone<ActiviteDiagnostique>[]>>()
    watchEffect(() => {
        activitesDiagnostique.value = securedDataArrayMap(
            activitesDiagnostiqueOriginales.value,
            (activitesDiagnostique) =>
                buildOriginalAwareClone(toRaw(activitesDiagnostique))
        )
    })

    const activitesDiagnostiqueRefs: Ref<{
        [id: ActiviteDiagnostique['id']]: InstanceType<
            typeof SActiviteDiagnostique
        > | null
    }> = ref({})

    const activitesDiagnostiqueAFaireRefs: ComputedRef<
        Array<InstanceType<typeof SActiviteDiagnostique>>
    > = computed(() => {
        if (isUndefined(activitesDiagnostique.value?.data)) {
            return []
        }

        return activitesDiagnostique.value.data.reduce(
            (activitesDiagnostiquesAFaireRefs, activitesDiagnostique) => {
                const activiteDiagnostiqueAFaireRef =
                    activitesDiagnostiqueRefs.value[
                        activitesDiagnostique.original.id
                    ]
                if (
                    activitesDiagnostique.original.isDone() === false &&
                    isDefinedAndNotNull(activiteDiagnostiqueAFaireRef)
                ) {
                    activitesDiagnostiquesAFaireRefs.push(
                        activiteDiagnostiqueAFaireRef
                    )
                }

                return activitesDiagnostiquesAFaireRefs
            },
            [] as Array<InstanceType<typeof SActiviteDiagnostique>>
        )
    })

    // Activité action
    const {
        activitesAction: activitesActionOriginales,
        reload: reloadActivitesActionOriginales,
    } = useInterventionActivitesAction(
        toRef(() => props.interventionOriginale.id),
        serviceOfferId
    )

    const activitesAction =
        ref<VolatileSecuredData<OriginalAwareClone<ActiviteAction>[]>>()
    watchEffect(() => {
        activitesAction.value = securedDataArrayMap(
            activitesActionOriginales.value,
            (activitesAction) => buildOriginalAwareClone(toRaw(activitesAction))
        )
    })

    const activitésActionAFaire: ComputedRef<
        VolatileSecuredData<OriginalAwareClone<ActiviteAction>[]>
    > = computed(() => {
        return securedDataArrayFilter(
            activitesAction.value,
            (activiteAction) => activiteAction.original.isDone() === false
        )
    })

    const activitesActionAvecDurée: ComputedRef<
        VolatileSecuredData<OriginalAwareClone<ActiviteAction>[]>
    > = computed(() => {
        return securedDataArrayFilter(activitesAction.value, (activiteAction) =>
            isDefined(activiteAction.original.duree)
        )
    })

    const activitesActionSansDurée: ComputedRef<
        VolatileSecuredData<OriginalAwareClone<ActiviteAction>[]>
    > = computed(() => {
        return securedDataArrayFilter(activitesAction.value, (activiteAction) =>
            isUndefined(activiteAction.original.duree)
        )
    })

    const activitéActionsASupprimer: Ref<ActiviteAction[]> = ref([])
    function ajouterLActivitéActionAuxSupressions(
        activitéActionASupprimer: ActiviteAction
    ) {
        activitéActionsASupprimer.value.push(activitéActionASupprimer)
    }

    function retirerLActivitéActionDesSupressions(
        activitéActionASupprimer: ActiviteAction
    ) {
        activitéActionsASupprimer.value =
            activitéActionsASupprimer.value.filter(
                (activitéActionDéjàPrésente) => {
                    return (
                        activitéActionDéjàPrésente.id !==
                        activitéActionASupprimer.id
                    )
                }
            )
    }

    //Création de nouvelles activitées
    const activitésActionCréationRef =
        ref<InstanceType<typeof SActiviteActionCreation>>()

    //Gestion attributs liés à l'intervention
    const matérielConsommé = computed<string | undefined>({
        get() {
            return intervention.value?.clone?.materielConsomme
        },
        set(materielConsomme) {
            if (isUndefined(intervention.value?.clone)) {
                return
            }

            if (materielConsomme === '') {
                intervention.value.clone.materielConsomme = undefined
                return
            }
            intervention.value.clone.materielConsomme = materielConsomme
        },
    })

    //Etat de l'intervetion
    const activitesAFaireSontRéalisées: ComputedRef<boolean> = computed(() => {
        if (
            isUndefined(activitesDiagnostique.value?.data) ||
            isUndefined(activitesAction.value?.data)
        ) {
            return false
        }
        return (
            activitesDiagnostiqueAFaireRefs.value.every(
                (activiteDiagnostiqueRef) =>
                    activiteDiagnostiqueRef.isObligatoire
                        ? activiteDiagnostiqueRef.opérationComplétée
                        : true
            ) &&
            activitesAction.value.data.every((activiteAction) =>
                activiteAction.clone.isObligatoire
                    ? activiteAction.clone.isDone()
                    : true
            )
        )
    })

    const interventionPourSoldageIsValid = ref<boolean>(true)

    const isSaveableForm = computed(() => {
        return (
            isDefined(activitesDiagnostique.value?.data) &&
            isDefined(activitesAction.value?.data) &&
            activitésActionCréationRef.value?.activitésCompletés &&
            interventionPourSoldageIsValid.value
        )
    })

    const isSoldableForm = computed(() => {
        return (
            isSaveableForm.value &&
            activitesAFaireSontRéalisées.value &&
            props.interventionOriginale.isClosable()
        )
    })

    const isInterventionClosing = ref(false)

    function assertInterventionEstSoldable() {
        if (!props.interventionOriginale.isClosable() === true) {
            throw new SilabError(
                `L'intervention ne peut pas être cloturée, depuis son statut actuel : ${props.interventionOriginale.currentStatus?.label}`
            )
        }
        if (!activitesAFaireSontRéalisées.value) {
            throw new SilabError(
                `L'intervention ne peut pas être cloturée, car toutes les opérations prévues ne sont pas réalisées`
            )
        }
    }

    async function sauvegarderEtSolderIntervention() {
        if (
            isUndefined(activitesDiagnostique.value?.data) ||
            isUndefined(activitesAction.value?.data)
        ) {
            return
        }

        isInterventionClosing.value = true

        try {
            assertInterventionEstSoldable()

            await sauvegarderTraitementIntervention()

            await interventionApi.close(
                serviceOfferId.value,
                props.interventionOriginale.id
            )
        } finally {
            isInterventionClosing.value = false
        }
    }

    const modeSuppressionDesActivitesAction = ref<boolean>(false)
    const estEnTrainDeSupprimerLesActivitesAction = ref<boolean>(false)

    async function sauvegarderTraitementIntervention() {
        if (
            isUndefined(activitesDiagnostique.value?.data) ||
            isUndefined(activitesAction.value?.data)
        ) {
            return
        }
        if (!activitésActionCréationRef.value?.activitésCompletés) {
            throw new SilabError(`Les temps déclarés ne sont pas complets`)
        }

        isInterventionSaving.value = true

        try {
            //Passer le mode de suppression à false permet de mettre à zéro le tableau des suppressions.
            //Cela évite une désynchronisation entre le tableau des suppressions et la liste activiteActionItem qui va être recrée.
            modeSuppressionDesActivitesAction.value = false

            await réaliserActivitesDiagnostiqueAFaireComplétées()
            await réaliserActivitesActionAFaireComplétées()
            await sauvegarderInterventionPourSoldage()
            await activitésActionCréationRef.value
                ?.déclarerActivités()
                .catch((error) => {
                    throw error
                })
            activitésActionCréationRef.value?.resetAttributsCommunsAuxActivité()
            //On rafraichie les données à la toutes fin car la modification de ces données va recréer les clones et pourrait poser des problèmes si c'était fait avant
            await reloadActivitesActionOriginales()
            await reloadActivitesDiagnostiqueOriginales()
        } finally {
            isInterventionSaving.value = false
        }
    }

    async function réaliserActivitesDiagnostiqueAFaireComplétées() {
        const activitesDiagnostiqueMisesAJour: ActiviteDiagnostique[] = []

        for (const activiteDiagnostiqueAFaireRef of activitesDiagnostiqueAFaireRefs.value) {
            if (activiteDiagnostiqueAFaireRef.opérationComplétée) {
                activitesDiagnostiqueMisesAJour.push(
                    await activiteDiagnostiqueAFaireRef.validerActivite()
                )
            }
        }

        // Note importante : il est important de ne pas toucher aux activité diagnostiques "originales"
        // sous peine de perdre les données des autres clones par écrasement
    }

    async function réaliserActivitesActionAFaireComplétées() {
        if (
            isUndefined(activitésActionAFaire.value?.data) ||
            isUndefined(activitesActionOriginales)
        ) {
            return
        }

        if (
            !userStore.currentUserHasRoleForServiceOffer(
                'INTERVENTION_MODIFIER_ACTIVITE',
                serviceOfferId.value
            )
        ) {
            return
        }

        const activitesActionMisesAJour: ActiviteDiagnostique[] = []
        for (const activiteActionAFaire of activitésActionAFaire.value.data) {
            if (activiteActionAFaire.clone.isDone()) {
                activitesActionMisesAJour.push(
                    await activiteActionApi.update(
                        serviceOfferId.value,
                        activiteActionAFaire.clone.id,
                        activiteActionMapper.toEditDto(
                            activiteActionAFaire.clone
                        )
                    )
                )
            }
        }
        // Note importante : il est important de ne pas toucher aux activité diagnostiques "originales"
        // sous peine de risquer de perdre les données des autres clones par écrasement
    }

    async function sauvegarderInterventionPourSoldage() {
        const interventionPourSoldage = {
            dateDeDebut: intervention.value.clone.dateDeDebut,
            dateDeFin: intervention.value.clone.dateDeFin,
            materielConsomme: intervention.value.clone.materielConsomme,
        }

        const interventionPourSoldageDto =
            interventionPourSoldageMapper.toEditDto(interventionPourSoldage)

        await interventionApi.putInterventionPourSoldage(
            serviceOfferId.value,
            intervention.value.clone.id,
            interventionPourSoldageDto
        )
    }

    const isInterventionSaving = ref(false)

    const champMatérielConsomméMaxLength = 250
    const rules = {
        leCHampMatérielEtAssezCourt: (input: string) =>
            isDefined(input)
                ? input.length <= champMatérielConsomméMaxLength ||
                  `Le texte est limité à ${champMatérielConsomméMaxLength} caractères pour le moment`
                : true,
    }

    async function traiterActivitesActionASupprimer() {
        estEnTrainDeSupprimerLesActivitesAction.value = true

        for (const activitéActionASupprimer of [
            ...activitéActionsASupprimer.value,
        ]) {
            await activiteActionApi.delete(
                serviceOfferId.value,
                activitéActionASupprimer.id
            )

            const indexActivitéActionsASupprimer =
                activitéActionsASupprimer.value.indexOf(
                    activitéActionASupprimer
                )
            if (indexActivitéActionsASupprimer > -1) {
                activitéActionsASupprimer.value.splice(
                    indexActivitéActionsASupprimer,
                    1
                )
            }
        }
        await reloadActivitesActionOriginales()
        estEnTrainDeSupprimerLesActivitesAction.value = false
        modeSuppressionDesActivitesAction.value = false
    }

    const isProcessing = computed(
        () => isInterventionSaving.value || isInterventionClosing.value
    )

    const isDirty = computed(() => {
        for (const activiteDiagnostiqueAFaireRef of activitesDiagnostiqueAFaireRefs.value) {
            if (activiteDiagnostiqueAFaireRef.opérationComplétée) {
                return true
            }
        }

        if (activitésActionAFaire.value?.data) {
            for (const activiteActionAFaire of activitésActionAFaire.value
                .data) {
                if (activiteActionAFaire.clone.isDone()) {
                    return true
                }
            }
        }

        if (activitésActionCréationRef.value?.isDirty) {
            return true
        }

        return !intervention.value.clone.equals(props.interventionOriginale)
    })

    defineExpose({
        sauvegarderTraitementIntervention,
        sauvegarderEtSolderIntervention,
        isSaveableForm: readonly(isSaveableForm),
        isSoldableForm: readonly(isSoldableForm),
        isProcessing: readonly(isProcessing),
        isDirty: readonly(isDirty),
    })
</script>

<template>
    <v-row>
        <div class="d-flex align-center justify-end ps-4 pe-5 w-100">
            <p class="mr-5">Afficher déjà réalisés</p>
            <v-switch
                v-model="afficherActivitésDéjàRéalisées.filters.isDone"
                class="flex-grow-0"
                color="primary"
                hide-details
                inline
                data-cy="switch-a-faire-uniquement"
            >
            </v-switch>
        </div>

        <v-col v-if="isUndefined(activitesDiagnostique)" cols="12">
            <v-skeleton-loader
                type="heading, list-item-two-line, list-item-two-line"
            ></v-skeleton-loader>
        </v-col>
        <v-col
            v-if="
                isDefined(activitesDiagnostique?.data) &&
                activitesDiagnostique.data.length > 0
            "
            cols="12"
            md="12"
            data-cy="activites-diagnostiques-a-faire"
        >
            <h2
                data-cy="titre-activites-diagnostique"
                class="d-inline-block me-2"
            >
                Contrôles
            </h2>
            <span
                v-if="afficherActivitésDéjàRéalisées.filters.isDone === false"
                class="text-subtitle-2"
            >
                {{
                    activitesDiagnostique.data.filter((activité) =>
                        activité.original.isDone()
                    ).length
                }}
                déjà
                {{
                    pluralForm(
                        'réalisé',
                        activitesDiagnostique.data.filter((activité) =>
                            activité.original.isDone()
                        ).length
                    )
                }}
            </span>

            <v-list data-cy="list">
                <template
                    v-for="(
                        activiteDiagnostique, indexActiviteDiagnostique
                    ) in activitesDiagnostique.data.filter(
                        (activiteDiagnostique) =>
                            !activiteDiagnostique.original.isDone() ||
                            afficherActivitésDéjàRéalisées.filters.isDone
                    )"
                    :key="activiteDiagnostique.original.getItemId()"
                >
                    <v-divider
                        v-if="indexActiviteDiagnostique > 0"
                        class="my-3"
                    ></v-divider>
                    <s-activite-diagnostique
                        :ref="
                            (elementRef: any) => {
                                activitesDiagnostiqueRefs[
                                    activiteDiagnostique.clone.id
                                ] = elementRef
                            }
                        "
                        v-model="activiteDiagnostique.clone"
                        :data-cy="
                            'activite-diagnostique-' + indexActiviteDiagnostique
                        "
                        :is-locked="activiteDiagnostique.original.isDone()"
                        :service-offer-id="serviceOfferId"
                        :intervention="intervention.original"
                    />
                </template>
            </v-list>
        </v-col>
        <v-col v-if="isUndefined(activitesActionSansDurée)" cols="12">
            <v-skeleton-loader
                type="heading, list-item-two-line, list-item-two-line"
            ></v-skeleton-loader>
        </v-col>
        <v-col
            v-if="
                isDefined(activitesActionSansDurée?.data) &&
                activitesActionSansDurée.data.length > 0
            "
            class="retirer-padding-activite-action mb-2"
            cols="12"
            md="12"
            data-cy="activites-action"
        >
            <h2 data-cy="titre-activites-action" class="d-inline-block me-2">
                Actions
            </h2>
            <span
                v-if="afficherActivitésDéjàRéalisées.filters.isDone === false"
                class="text-subtitle-2"
            >
                {{
                    activitesActionSansDurée.data.filter((activite) => {
                        return activite.original.isDone()
                    }).length
                }}
                déjà
                {{
                    pluralForm(
                        'réalisée',
                        activitesActionSansDurée.data.filter((activite) => {
                            return activite.original.isDone()
                        }).length
                    )
                }}
            </span>
            <v-list>
                <template
                    v-for="(
                        activiteActionSansDurée, indexActiviteAction
                    ) in activitesActionSansDurée.data.filter(
                        (activitesActionSansDurée) =>
                            !activitesActionSansDurée.original.isDone() ||
                            afficherActivitésDéjàRéalisées.filters.isDone
                    )"
                    :key="activiteActionSansDurée.original.getItemId()"
                >
                    <v-divider
                        v-if="indexActiviteAction > 0"
                        class="my-0"
                    ></v-divider>
                    <s-activite-action-item
                        v-model="activiteActionSansDurée.clone"
                        :data-cy="
                            (activiteActionSansDurée.original.isDone()
                                ? 'activite-action-faites-'
                                : 'activite-action-a-faire-') +
                            indexActiviteAction
                        "
                        :est-modifiable="
                            !activiteActionSansDurée.original.isDone()
                        "
                        @suppression-demandée="
                            (activitéActionASupprimer) =>
                                ajouterLActivitéActionAuxSupressions(
                                    activitéActionASupprimer
                                )
                        "
                        @suppression-annulée="
                            (activitéActionASupprimer) =>
                                retirerLActivitéActionDesSupressions(
                                    activitéActionASupprimer
                                )
                        "
                    ></s-activite-action-item>
                </template>
            </v-list>
        </v-col>
        <v-col v-if="isUndefined(activitesActionAvecDurée)" cols="12">
            <v-skeleton-loader
                type="heading, list-item-two-line, list-item-two-line"
            ></v-skeleton-loader>
        </v-col>
        <v-col
            v-if="
                isDefined(activitesActionAvecDurée?.data) &&
                activitesActionAvecDurée.data.length > 0
            "
            class="retirer-padding-activite-action"
            cols="12"
            md="12"
            data-cy="activites-action"
        >
            <div
                class="d-flex flex-column align-md-center flex-md-row justify-md-space-between mb-3"
            >
                <h2
                    data-cy="titre-activites-action"
                    class="d-inline-block mb-3 mb-md-0"
                >
                    Temps Passés
                </h2>
                <v-btn
                    v-if="modeSuppressionDesActivitesAction === false"
                    append-icon="mdi-trash-can-outline"
                    size="small"
                    variant="outlined"
                    data-cy="supprimer-des-lignes-activites-actions"
                    @click="modeSuppressionDesActivitesAction = true"
                    >Supprimer des lignes</v-btn
                >
                <div
                    v-else
                    class="d-flex flex-column align-md-center flex-md-row"
                >
                    <v-btn
                        size="small"
                        class="mb-2 mb-md-0"
                        data-cy="annuler-suppression-activites-actions"
                        @click="modeSuppressionDesActivitesAction = false"
                        >Annuler</v-btn
                    >
                    <v-btn
                        append-icon="mdi-trash-can-outline"
                        size="small"
                        class="ml-md-4"
                        color="error"
                        :loading="estEnTrainDeSupprimerLesActivitesAction"
                        data-cy="supprimer-activites-actions"
                        @click="traiterActivitesActionASupprimer()"
                        >Supprimer</v-btn
                    >
                </div>
            </div>
            <v-list>
                <template
                    v-for="(
                        activiteActionAvecDurée, indexActiviteAction
                    ) in activitesActionAvecDurée.data.sort((a, b) => {
                        const dateA = a.clone.dateDeDebut
                            ? a.clone.dateDeDebut.getTime()
                            : 0
                        const dateB = b.clone.dateDeDebut
                            ? b.clone.dateDeDebut.getTime()
                            : 0
                        return dateA - dateB
                    })"
                    :key="activiteActionAvecDurée.original.getItemId()"
                >
                    <v-divider
                        v-if="indexActiviteAction > 0"
                        class="my-0"
                    ></v-divider>
                    <s-activite-action-item
                        v-model="activiteActionAvecDurée.clone"
                        :data-cy="
                            (activiteActionAvecDurée.original.isDone()
                                ? 'activite-action-faites-'
                                : 'activite-action-a-faire-') +
                            indexActiviteAction
                        "
                        :est-modifiable="
                            !activiteActionAvecDurée.original.isDone()
                        "
                        :mode-suppression="modeSuppressionDesActivitesAction"
                        @suppression-demandée="
                            (activitéActionASupprimer) =>
                                ajouterLActivitéActionAuxSupressions(
                                    activitéActionASupprimer
                                )
                        "
                        @suppression-annulée="
                            (activitéActionASupprimer) =>
                                retirerLActivitéActionDesSupressions(
                                    activitéActionASupprimer
                                )
                        "
                    ></s-activite-action-item>
                </template>
            </v-list>
        </v-col>
        <v-form
            v-model="interventionPourSoldageIsValid"
            class="w-100 px-3 mb-10"
            @submit.prevent
        >
            <v-row>
                <v-col
                    v-if="
                        interventionServiceOffer?.data
                            ?.gestionRecompletementActif
                    "
                    cols="12"
                    md="12"
                    data-cy="demande-de-recompletement"
                >
                    <h2 class="mt-5" data-cy="titre-demande-de-recompletement">
                        Matériel consommé
                    </h2>
                    <v-textarea
                        v-model="matérielConsommé"
                        label="Liste des materiels à réapprovisionner"
                        variant="outlined"
                        class="mt-1"
                        data-cy="liste-materiels-demande-de-recompletement"
                        hint="Laisser vide si aucun matériel consommé"
                        persistent-hint
                        hide-details="auto"
                        auto-grow
                        :rules="[rules.leCHampMatérielEtAssezCourt]"
                        counter="250"
                    ></v-textarea>
                </v-col>
                <template
                    v-if="
                        interventionServiceOffer?.data
                            ?.gestionDatesPourInterventionActif
                    "
                >
                    <v-col cols="12"><h2>Dates de l'intervention</h2></v-col>
                    <s-date-range-field
                        v-model:date-de-debut="intervention.clone.dateDeDebut"
                        v-model:date-de-fin="intervention.clone.dateDeFin"
                        :use-time="true"
                        :is-required="true"
                    />
                </template>
            </v-row>
        </v-form>
        <v-col cols="12" md="12" data-cy="déclaration-activité">
            <h2>Ajouter une activité</h2>
            <s-activite-action-creation
                v-if="
                    isDefined(myself) &&
                    isDefined(intervention?.original?.intervenantsAffectes)
                "
                ref="activitésActionCréationRef"
                v-model:activités-action-originales="activitesActionOriginales"
                :intervention="intervention.original"
                :logged-in-gmao-acteur="myself"
            >
            </s-activite-action-creation>
            <v-skeleton-loader
                v-else
                type="list-item, list-item, list-item, list-item-two-line,"
            >
            </v-skeleton-loader>
        </v-col>
        <v-col>
            <v-alert
                v-if="activitéActionsASupprimer.length > 0"
                type="warning"
                data-cy="avertissement-activité-en-suppression"
            >
                Vous n'avez pas confirmé la suppression des Temps Passés, ces
                modifications seront perdues si vous enregistrez ou soldez !
            </v-alert>
            <v-alert v-if="!isSoldableForm && isSaveableForm" type="info">
                Pour SOLDER l'intervention, toutes les actions et contrôles
                obligatoires (*) doivent être complétés.
            </v-alert>
        </v-col>
    </v-row>
</template>
<style lang="scss">
    .retirer-padding-activite-action {
        .v-card-item {
            padding: 0;
        }
        .v-card-text {
            padding-right: 0;
        }
    }
</style>
